/* Pong - A version of Pong based on Ncurses
 * Copyright (C) 1999 Jeffrey Wade Starr <starr81@ix.netcom.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */   

// paddle.h
// Pong Header File - for paddle and ball specifications
// By Jeffrey W. Starr Oct 11 1998

#ifndef PADDLE_H
#define PADDLE_H

class Paddle
{
 public:
  Paddle();                        // constructor
  void mvRight();
  void mvLeft();
  int getXc();

 private:
  void showPaddle();

  int distTop, distEdge;
};

Paddle::Paddle()
{
  // Put down initial coordinates
  distTop = 22;
  distEdge = 40;
  
  showPaddle();
}

inline int Paddle::getXc()
{
  return distEdge;
}

inline void Paddle::mvRight()
{
  // Move paddle away from left edge
  if(distEdge <= 77)
    distEdge++;
  showPaddle();
}

inline void Paddle::mvLeft()
{
  // Move paddle toward left edge
  if(distEdge >= 2)
    distEdge--;
  showPaddle();
}

void Paddle::showPaddle()
{
  // First, clean up after last paddle (slow)
  mvaddch(distTop, distEdge, ' ');
  mvaddch(distTop, distEdge + 1, ' ');
  mvaddch(distTop, distEdge + 2, ' ');
  mvaddch(distTop, distEdge - 1, ' ');
  mvaddch(distTop, distEdge - 2, ' ');
  
  mvaddch(distTop, distEdge, '#');      // center of paddle
  mvaddch(distTop, distEdge - 1, '#');  // left edge
  mvaddch(distTop, distEdge + 1, '#');  // right edge
  refresh();
}

#endif










